/************************************************************************/
/* FileName:        LED.S						*/
/* Processor:       PIC32MX795						*/
/* Assembler/Linker:MPLAB C32						*/
/* Author:	    George Dell						*/
/* Date:	    12/23/10						*/
/************************************************************************/
#define _CP0_HWRENA                            $7, 0
#define _CP0_BADVADDR                          $8, 0
#define _CP0_COUNT                             $9, 0
#define _CP0_COMPARE                           $11, 0
#define _CP0_STATUS                            $12, 0
#define _CP0_INTCTL                            $12, 1
#define _CP0_SRSCTL                            $12, 2
#define _CP0_SRSMAP                            $12, 3
#define _CP0_CAUSE                             $13, 0
#define _CP0_EPC                               $14, 0
#define _CP0_PRID                              $15, 0
#define _CP0_EBASE                             $15, 1
#define _CP0_CONFIG                            $16, 0
#define _CP0_CONFIG1                           $16, 1
#define _CP0_CONFIG2                           $16, 2
#define _CP0_CONFIG3                           $16, 3
#define _CP0_DEBUG                             $23, 0
#define _CP0_TRACECONTROL                      $23, 1
#define _CP0_TRACECONTROL2                     $23, 2
#define _CP0_USERTRACEDATA                     $23, 3
#define _CP0_TRACEBPC                          $23, 4
#define _CP0_DEBUG2                            $23, 5
#define _CP0_DEPC                              $24, 0
#define _CP0_ERROREPC                          $30, 0
#define _CP0_DESAVE                            $31, 0


	.global main
//				*** $BF80 ($t8) ***
#define UBASE	0x6400		// U2=6200=GEO , U3=6400=NICK
#define U3MODE	UBASE+0x00
#define U3MODECLR UBASE+0x04
#define U3MODESET UBASE+0x08
#define U3STA	UBASE+0x10
#define U3STACLR UBASE+0x14
#define U3STASET UBASE+0x18
#define U3TXREG UBASE+0x20
#define U3RXREG UBASE+0x30
#define U3BRG	UBASE+0x40

//				*** $BF88 ($t9) ***

#define CHECON	0x4000
#define	TRISA	0x6000
#define	TRISACLR 0x6004
#define	TRISASET 0x6008
#define	PORTA	0x6010
#define	PORTACLR 0x6014
#define	PORTASET 0x6018
#define	LATA	0x6020
#define	LATACLR	0x6024
#define	LATASET	0x6028
#define LATAINV	0x602C
#define TRISB	0x6040
#define TRISBCLR 0x6044
#define TRISBSET 0x6048
#define PORTB	0x6050
#define PORTBCLR 0x6054
#define PORTBSET 0x6058
#define PORTBINV 0x605C
#define	LATB	0x6060
#define	LATBCLR	0x6064
#define	LATBSET	0x6068
#define	LATBINV 0x606C
#define TRISC	0x6080
#define TRISCCLR 0x6084
#define TRISCSET 0x6088
#define PORTC	0x6090
#define PORTCCLR 0x6094
#define PORTCSET 0x6098
#define PORTCINV 0x609C
#define	LATC	0x60A0
#define	LATCCLR	0x60A4
#define	LATCSET	0x60A8
#define	LATCINV 0x60AC
#define	TRISD	0x60C0
#define TRISDCLR 0x60C4
#define TRISDSET 0x60C8
#define PORTD	0x60D0
#define	PORTDCLR 0x60D4
#define	PORTDSET 0x60D8
#define LATD	0x60E0
#define LATDCLR	0x60E4
#define LATDSET	0x60E8
#define LATDINV 0x60EC
#define TRISE	0x6100
#define	TRISECLR 0x6104
#define	TRISESET 0x6108
#define PORTE	0x6110
#define	PORTECLR 0x6114
#define	PORTESET 0x6118
#define LATE	0x6120
#define LATECLR	0x6124
#define LATESET	0x6128
#define LATEINV 0x612C
#define TRISF	0x6140
#define	TRISFCLR 0x6144
#define	TRISFSET 0x6148
#define PORTF	0x6150
#define	PORTFCLR 0x6154
#define	PORTFSET 0x6158
#define LATF	0x6160
#define	LATFCLR 0x6164
#define	LATFSET 0x6168
#define	TRISG	0x6180
#define	TRISGCLR 0x6184
#define	TRISGSET 0x6188
#define	PORTG	0x6190
#define	PORTGCLR 0x6194
#define	PORTGSET 0x6198
#define LATG	0x61A0
#define LATGCLR	0x61A4
#define LATGSET	0x61A8
#define LATGINV	0x61AC
#define CNCON	0x61C0
#define CNCONCLR 0x61C4
#define CNCONSET 0x61C8
#define CNEN	0x61D0
#define CNENCLR	0x61D4
#define CNENSET	0x61D8
#define	CNPUE	0x61E0
#define	CNPUECLR 0x61E4
#define	CNPUESET 0x61E8
/*********************************************************************/
/*			   RESET PROCESS			     */
/*********************************************************************/
.section .reset,"ax",@progbits
.set noreorder
.ent _reset
_reset:	la	$t0,_startup	// *** reset vector ***
	jr	$t0
	nop
.end _reset

.globl _reset

	.section .startup,"ax",@progbits
	.set noreorder
.ent _startup
_startup:
	mfc0	$k0,_CP0_CAUSE
	ext	$k0,$k0,19,1
	beqz	$k0,_no_nmi
	nop
	eret

_no_nmi:
	la	$sp,0xA0020000		// 128K

	mtc0	$zero,_CP0_COUNT
	li	$t2,-1
	mtc0	$t2,_CP0_COMPARE

	la	$t1,_ebase_address
	mtc0	$t1,_CP0_EBASE

	la	$t1,_vector_spacing
	li	$t2,0
	ins	$t2,$t1,5,5
	mtc0	$t2,_CP0_INTCTL

	li	$t1,0x00800000
	mtc0	$t1,_CP0_CAUSE

	mfc0	$t0,_CP0_CONFIG
	ext	$t1,$t0,22,1
	sll	$t1,$t1,17
	mfc0	$t0,_CP0_STATUS
	and	$t0,$t0,0x00580000
	or	$t0,$t1,$t0
	mtc0	$t0,_CP0_STATUS

	mfc0	$t0,_CP0_STATUS
	and	$t0,$t0,0xFFBFFFFF
	mtc0	$t0,_CP0_STATUS

	di				// disable all interrupts
	lui	$t8,0xBF80		// set peripherial base address
	lui	$t9,0xBF88		// set gpio base address
	lui	$gp,0xA000		// set internal ram base address


	li	$t0,0x0100		// *** TEST FOR BOOTLOADER ENTRY ***
	sw	$t0,CNPUE($t9)		// enable CN8/RG6 pull up resistor 

	li	$t0,1000
0:	bne	$t0,$zero,0b		// short delay
	addiu	$t0,-1

	lw	$t0,PORTG($t9)		// read inputs
	andi	$t0,0x0040		// request bootloader (RG6)?
	beq	$t0,$zero,BLOAD		// yes, branch
	lui	$t0,0x9D00
	ori	$t0,0x1000
	jr	$t0			// jump to user code (0x9D001000)
	nop

					// *** BOOT LOADER ***
BLOAD:	li	$t0,0x32		// all code space cached : 2-wait states
	sw	$t0,CHECON($t9)		// set flash wait states

					// ** INITIALIZE UART3 **
	li	$t0,43			// get 115.2K baud
	sw	$t0,U3BRG($t8)		// set baud
	li	$t0,0x8900
	sw	$t0,U3MODE($t8)		// enable U3 uart
	li	$t0,0x1400
	sw	$t0,U3STA($t8)		// enable tx & rx
	lw	$t0,U3RXREG($t8)	// empty receive buffer
	li	$t1,0x0002
	sw	$t1,U3STACLR($t8)	// clear u3 overrun flag

					// ** TRANSMIT SIGN ON MESSAGE **
	jal	PUTU3			// send <cr>
	li	$a0,13
	jal	PUTU3			// send code revision
	li	$a0,'1'
	jal	PUTU3
	li	$a0,'.'
	jal	PUTU3
	li	$a0,'1'

/*********************************************************************/
					// ** MAIN MENU **
MMENU:	jal	PUTU3			// send <cr>
	li	$a0,13
	jal	PUTU3			// send <lf>
	li	$a0,10
	jal	GETU3			// wait for command
	nop
	jal	PUTU3			// echo command
	andi	$a0,0xDF		// convert lower case -> upper case

/*********************************************************************/
ER:	li	$t0,'E'			// Erase?
	bne	$a0,$t0,BC		// no, branch
	nop
//					// *** ERASE USER CODE SPACE ***
	la	$s1,NVMCON
	sw	$zero,0($s1)		// make sure nvmwren = 0
	li	$t0,0x4005
	sw	$t0,0($s1)		// set nvm operation (erase all PFM)
	li	$t0,0xAA996655
	li	$t1,0x556699AA
	li	$t2,0x8000
	sw	$t0,0x10($s1)		// write keys
	sw	$t1,0x10($s1)
	sw	$t2,0x08($s1)		// start unlock & erase operation

4:	lw	$t0,0($s1)		// done?
	andi	$t0,0x8000
	bne	$t0,$zero,4b		// no, loop
	li	$t0,20			// 20*12.5nS=500nS
6:	bne	$t0,$zero,6b		// delay 500nS
	addiu	$t0,-1
	jal	PUTU3			// send Complete
	li	$a0,'C'
	beq	$zero,$zero,MMENU
/*********************************************************************/
BC:	li	$t0,'B'			// Blank check?
	bne	$a0,$t0,PG		// no, branch

					// *** BLANK CHECK USER MEMORY ***
	lui	$a1,0x9D00		// point to start of user memory
	lui	$a2,0x9D08		// point to end of user memory (512K)
	li	$t4,-1			// get blank memory value
2:	lw	$t0,0($a1)		// blank memory?
	lw	$t1,4($a1)
	lw	$t2,8($a1)
	lw	$t3,12($a1)
	and	$t0,$t1
	and	$t0,$t2
	and	$t0,$t3
	bne	$t0,$t4,4f		// no, branch
	addiu	$a1,16			// (advance source pointer)
	bne	$a1,$a2,2b		// done? no, loop
	nop
	jal	PUTU3			// send Success
	li	$a0,'S'
	beq	$zero,$zero,MMENU
	nop
4:	jal	PUTU3			// send Fail
	li	$a0,'F'
	beq	$zero,$zero,MMENU
/*********************************************************************/
PG:	li	$t0,'P'			// Program?
	bne	$a0,$t0,VE		// no, branch

	lui	$a3,0x1D00		// point to PFM

					// ** GET 512 BYTES FROM UART OR TIMEOUT **
1:	jal	PUTU3			// send cr
	li	$a0,13
	jal	PUTU3			// send lf
	li	$a0,10
	jal	PUTU3			// send XON
	li	$a0,'G'
	jal	PUTU3			// send cr
	li	$a0,13
	jal	PUTU3			// send lf
	li	$a0,10
	ori	$a1,$gp,0x1000		// set ram destination pointer

2:	lui	$s4,300			// get timeout interval

3:	addiu	$s4,-1			// timeout?
	beq	$s4,$zero,4f		// yes, branch
	lw	$v0,U3STA($t8)		// get status
	andi	$v1,$v0,0x0001		// receive data?
	beq	$v1,$zero,3b		// no, branch
	andi	$v1,$v0,0x0002		// isolate OERR bit
	sw	$v1,U3STACLR($t8)	// clear OERR (if necessary)
	lbu	$a0,U3RXREG($t8)	// read received data
	sb	$a0,0($a1)		// write to ram buffer
	addiu	$a1,1			// advance destination pointer
	andi	$v0,$a1,0x01FF		// received 512 bytes?
	bne	$v0,$zero,2b		// no, loop
	nop

4:	jal	PUTU3			// send XOFF
	li	$a0,'W'
	jal	PUTU3			// send cr
	li	$a0,13
	jal	PUTU3			// send lf
	li	$a0,10
					// ** WRITE 512 BYTES TO CPU FLASH **
	sw	$a3,0x20($s1)		// set nvmadr
	li	$t0,0x1000		// get physical address of source ram
	sw	$t0,0x40($s1)		// set nvmsrcaddr
	sw	$zero,0($s1)		// clear nvmwren
	li	$t0,0x4003
	sw	$t0,0($s1)		// set nvm operation (program row)
	li	$t0,0xAA996655
	li	$t1,0x556699AA
	li	$t2,0x8000
	sw	$t0,0x10($s1)		// write keys
	sw	$t1,0x10($s1)
	sw	$t2,0x08($s1)		// start unlock & program operation

6:	lw	$t1,0($s1)		// write row complete?
	andi	$t0,$t1,0x8000
	bne	$t0,$zero,6b		// no, loop
	nop
	addiu	$a3,512			// advance destination flash pointer
	bne	$s4,$zero,1b		// timeout? no, loop
	sw	$zero,0($s1)		// turn off nvmwren

	jal	PUTU3			// send XON
	li	$a0,'G'
	jal	PUTU3			// send cr
	li	$a0,13
	jal	PUTU3			// send lf
	li	$a0,10
	jal	PUTU3			// send Complete
	li	$a0,'C'
	beq	$zero,$zero,MMENU
/*********************************************************************/
VE:	li	$t0,'V'			// Verify?
	bne	$a0,$t0,RE		// no, branch

	lui	$a2,0x9D00		// get source address

2:	lui	$t0,100			// get timeout interval

4:	addiu	$t0,-1			// timeout?
	beq	$t0,$zero,8f		// yes, branch
	lw	$v0,U3STA($t8)		// get status
	andi	$v1,$v0,0x0001		// receive data?
	beq	$v1,$zero,4b		// no, branch
	andi	$v1,$v0,0x0002		// isolate OERR bit
	sw	$v1,U3STACLR($t8)	// clear OERR (if necessary)
	lbu	$a0,U3RXREG($t8)	// read received data
	lbu	$a1,0($a2)		// get flash data
	addiu	$a2,1			// advance source pointer
	beq	$a0,$a1,2b		// verified? yes, loop
	nop

	jal	PUTU3			// send Fail
	li	$a0,'F'
	beq	$zero,$zero,MMENU
	nop

8:	jal	PUTU3			// send Success
	li	$a0,'S'
	beq	$zero,$zero,MMENU
	nop
/*********************************************************************/
RE:	li	$t0,'R'			// Reset?
	bne	$a0,$t0,MMENU		// no, branch

	li	$t2,1
	la	$a0,SYSKEY
	la	$a1,RSWRSTSET
	la	$a2,RSWRST
	li	$t0,0xAA996655
	li	$t1,0x556699AA
	sw	$t0,0($a0)
	sw	$t1,0($a0)
	sw	$t2,0($a1)		// software reset
	lw	$t2,0($a2)
	nop
	nop
	nop
	nop
	beq	$zero,$zero,MMENU
	nop
/*********************************************************************/
/*********************************************************************/
/*	GETU3 - RECEIVE BYTE FROM UART 3			     */
/*********************************************************************/
GETU3:	lw	$v0,U3STA($t8)		// get status
	andi	$v1,$v0,0x0001		// receive data?
	beq	$v1,$zero,GETU3		// no, branch
	andi	$v1,$v0,0x0002		// isolate OERR bit
	sw	$v1,U3STACLR($t8)	// clear OERR (if necessary)
	jr	$ra			// return
	lw	$a0,U3RXREG($t8)	// READ DATA
/*********************************************************************/
/*	PUTU3 - TRANSMIT BYTE TO UART 3				     */
/*********************************************************************/
PUTU3:	lw	$v0,U3STA($t8)		// get status
	andi	$v0,0x0100		// tx buffer empty?
	beq	$v0,$zero,PUTU3		// no, loop
	nop
	jr	$ra			// return
	sw	$a0,U3TXREG($t8)	// transmit data
/*********************************************************************/
.end _startup

/*********************************************************************/
.config_BFC02FF0 = 0xFFFFFFFF;		// devcfg3
.config_BFC02FF4 = 0xFFF8FFD9;		// devcfg2
.config_BFC02FF8 = 0xFF7FCDDB;		// devcfg1
.config_BFC02FFC = 0x7FFFFFFF;		// devcfg0


/*********************************************************************/

.section .bev_handler,"ax",@progbits
.set noreorder
.ent _bev_exception
_bev_exception:
0:	lui	$t9,0xBF88		// set gpio base address
	li	$t0,0x02		// disable cache : 2-wait states
	sw	$t0,CHECON($t9)		// set flash wait states



6:
	beq	$zero,$zero,0b
	nop
.end _bev_exception

/*********************************************************************/
.section .gen_handler,"ax",@progbits
.set noreorder
.ent _gen_exception
_gen_exception:
0:	lui	$t9,0xBF88		// set gpio base address
	li	$t0,0x02		// disable cache : 2-wait states
	sw	$t0,CHECON($t9)		// set flash wait states
	mfc0	$t1,$13			// get cause register
	srl	$t1,2			// reposition exception code bits
	andi	$t1,0x0F		// isolate exception code bits


	mfc0	$t1,$14			// get exception pc
	li	$t2,32

0:	beq	$zero,$zero,0b
	nop
.end _gen_exception
/*********************************************************************/
.text
.set noreorder
.ent main

main:	lui	$t9,0xBF88		// set gpio base address
	li	$t0,0x32		// all code space cached : 2-wait states
	sw	$t0,CHECON($t9)		// set flash wait states
	nop
	nop

	li	$a0,0x1000		// get bit-12 mask
	sw	$a0,TRISGCLR($t9)	// enable RG12 as output
2:	lui	$t0,100			// set delay time
4:	bne	$t0,$zero,4b		// wait for delay to finish
	addiu	$t0,-1
	beq	$zero,$zero,2b		// loop forever
	sw	$a0,LATGINV($t9)	// toggle output

.end main
